Overview | Package | Class | Tree | Deprecated | Index | Help
| Openfire 3.4.3 Javadoc
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.jivesoftware.openfire.net
Class ServerTrustManager

    java.lang.Object
      org.jivesoftware.openfire.net.ServerTrustManager

All Implemented Interfaces:
  TrustManager, X509TrustManager

    public class ServerTrustManager

extends Object
implements X509TrustManager

ServerTrustManager is a Trust Manager that is only used for s2s connections. This TrustManager is used both when the server connects to another server as well as when receiving a connection from another server. In both cases, it is possible to indicate if self-signed certificates are going to be accepted. In case of accepting a self-signed certificate a warning is logged. Future version of the server might include a small workflow so admins can review self-signed certificates or certificates of unknown issuers and manually accept them.

Author:
  Gaston Dombiak

Constructor Summary
`ServerTrustManager(String server, KeyStore trustTrust)`

Method Summary
`void` | `checkClientTrusted(X509Certificate[] x509Certificates, String string)`
`void` | `checkServerTrusted(X509Certificate[] x509Certificates, String string)` Given the partial or complete certificate chain provided by the peer, build a certificate path to a trusted root and return if it can be validated and is trusted for server SSL authentication based on the authentication type.
`X509Certificate[]` | `getAcceptedIssuers()`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### ServerTrustManager

    public ServerTrustManager(String server,
                              KeyStore trustTrust)

Method Detail

### checkClientTrusted

    public void checkClientTrusted(X509Certificate[] x509Certificates,
                                   String string)

  Specified by:
    `checkClientTrusted` in interface `X509TrustManager`

### checkServerTrusted

    public void checkServerTrusted(X509Certificate[] x509Certificates,
                                   String string)
                            throws CertificateException

  Given the partial or complete certificate chain provided by the peer, build a certificate path to a trusted root and return if it can be validated and is trusted for server SSL authentication based on the authentication type. The authentication type is the key exchange algorithm portion of the cipher suites represented as a String, such as "RSA", "DHE_DSS". Note: for some exportable cipher suites, the key exchange algorithm is determined at run time during the handshake. For instance, for TLS_RSA_EXPORT_WITH_RC4_40_MD5, the authType should be RSA_EXPORT when an ephemeral RSA key is used for the key exchange, and RSA when the key from the server certificate is used. Checking is case-sensitive.

  By default certificates are going to be verified. This includes verifying the certificate chain, the root certificate and the certificates validity. However, it is possible to disable certificates validation as a whole or each specific validation.

  Specified by:
    `checkServerTrusted` in interface `X509TrustManager`
  Parameters:
    `x509Certificates` - an ordered array of peer X.509 certificates with the peer's own certificate listed first and followed by any certificate authorities.
    `string` - the key exchange algorithm used.
  Throws:
    `CertificateException` - if the certificate chain is not trusted by this TrustManager.

### getAcceptedIssuers

    public X509Certificate[] getAcceptedIssuers()

  Specified by:
    `getAcceptedIssuers` in interface `X509TrustManager`

Overview | Package | Class | Tree | Deprecated | Index | Help
| Openfire 3.4.3 Javadoc
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2003-2007 Jive Software.